
import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Line2D;
import java.awt.geom.Ellipse2D;
import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: unknown
 * Date: Oct 13, 2004
 * Time: 3:20:52 PM
 * To change this template use File | Settings | File Templates.
 */
public class J2Dapi34 extends JFrame {
    JPanel screen;
    JPanel controls;
    int g2xOrigin, g2yOrigin;
    int g2Scale;
    double g2rotate;
    int width;
    int height;
    Insets ins;
    AffineTransform atG2;
    AffineTransform atRotate30;
    AffineTransform g2aff;
    Vector shapes;

    public J2Dapi34(String title) {
        super(title);

        this.setSize(500, 500);
        width = getWidth();
        height = getHeight();
        this.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        ins = this.getInsets();
        System.out.println("ins.top" + ins.top);
        shapes = setUpFigures();
        this.setVisible(true);
    }

    private JPanel getScreen() {
        JPanel jp = new JPanel(true);
        jp.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                int x = e.getX();
                int y = e.getY();
                System.out.println("x = " + x + ";  y = " + y);
               // parent.repaint();
            }
        });
        return jp;
    }

    private Vector setUpFigures() {
        Vector v = new Vector();
        float centerX = 0f;
        float centerY = 0f;
        float diameter = 10f;
        float radius = diameter / 2;
        Ellipse2D.Float circle =
                new Ellipse2D.Float(centerX - radius, centerY - radius, 10, 10);
        v.add(circle);
        /*
 From http://www.apl.jhu.edu/~hall/java/Java2D-Tutorial.html#Java2D-Tutorial-Shapes-Classes

        private GradientPaint gradient =
           new GradientPaint(0, 0, Color.red, 175, 175, Color.yellow,
                             true); // true means to repeat pattern

         public void paintComponent(Graphics g) {
           clear(g);
           Graphics2D g2d = (Graphics2D)g;
           drawGradientCircle(g2d);
         }

        */

        Rectangle2D rect = new Rectangle2D.Float(5.0f, 15.0f, 17.0f, 17.0f);
        Rectangle2D rectC = new Rectangle2D.Float(-5f, -5f, 10.0f, 10.0f);
        v.add(rect);
        v.add(rectC);
        for (int i = 1; i <= 5; i++) { //Pencil of lines through origin
            Line2D line = new Line2D.Float(centerX, centerY, 10f + 10 * i, 10f);
            v.add(line);
        }
        return v;
    }

    public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        atG2 = g2.getTransform();
        System.out.println("atG2g2 = " + atG2);
        System.out.println("g2.getStroke() = " + g2.getStroke());
        g2.scale(10, -10);   //reflect and scale coordinates
        g2.translate(5, -40);
        System.out.println("g2.getTransform = " + g2.getTransform());
        BasicStroke bst = (BasicStroke) g2.getStroke();
        System.out.println("g2.getStroke() = " + bst.getLineWidth());
        //Default stroke is 1 pixel, but scales with g2!!!!
        g2.setXORMode(Color.yellow);
        g2.setStroke(new BasicStroke(.1f));
        drawShapeVector(g2, shapes);

        // Rotate about arbitrary (scaled) center
        //   g2.translate(-5, 40);
        //sonuvabitch rotates about translated center!!!!
        g2.rotate(Math.PI / 6.0);
        //   g2.translate(5, -40);

        drawShapeVector(g2, shapes);
        System.out.println("g2.getTransform = " + g2.getTransform());
    }

    private void drawShapeVector(Graphics2D g2d, Vector vShapes) {
        Shape sh;
        for (int i = 0; i < vShapes.size(); i++) {
            sh = (Shape) vShapes.elementAt(i);
            g2d.draw(sh);
        }
    }

    public static void main(String[] args) {
        new J2Dapi34("Page 34, Programmers Guide to J2D API");
    }
}
