
import javax.swing.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.*;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;

/**
 * Created by IntelliJ IDEA.
 * User: unknown
 * Date: Oct 16, 2004
 * A Panel for drawing figures upon, with mousing demo.
 */
public class SelfContainedPanel extends JPanel {
    float mouseX, mouseY;
    Color newColor = Color.GREEN;
    MouseMotionAdapter ma;
    float radiusFromJFrame;
    int paintCount = 0;
    Color backGroundColor;

    public SelfContainedPanel(float radius, Color c) {
        super(false); // is double buffered
        backGroundColor = c;
        this.setBackground(c);
        System.out.println("backGroundColor = " + backGroundColor);
        radiusFromJFrame = radius;
        ma = new MouseMotionAdapter() {
            public void mouseDragged(MouseEvent e) {
                mouseX = (float) e.getX();
                mouseY = (float) e.getY();
                System.out.println("( x , y ) =   ( " + mouseX + " , " + mouseY + " )");
                repaint();
            }
        };
        this.addMouseMotionListener(ma);
    }
    public Dimension getPreferredSize(){
        return new Dimension(300,300);
    }
    public float getMouseX() {
        return mouseX;
    }

    public void paint(Graphics g) {   // or: public void paintComponent(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        if (paintCount == 0)
            super.paint(g);  // This step erases previous drawings on the buffer and sets background!!
        paintCount++;
        System.out.println("paintCount = " + paintCount);

        if (paintCount % 10 == 0) // doesn't work!
            super.setBackground(new Color(20, 100 + paintCount % 100, 255 - paintCount % 200));
        if (paintCount > 300)
            this.setBackground(Color.white);
        if (paintCount < 200)
            rectInt(g2);
        if (paintCount < 100)
            textDraw(g2);
        mousePaint(g2);   // This passes a Graphics argument up to g
    }

    public void setBackGround(Color c) {
        this.setBackground(c);
    }

    private void mousePaint(Graphics2D g2) {
        // super.paint(g2);  // This step erases previous drawings on the buffer!!
        g2Paint(g2);
    }

    private void g2Paint(Graphics2D gg2) {
        //super.paint(gg2);  // This step erases previous drawings on the buffer!!
        gg2.setColor(Color.ORANGE);
        //  g2.setClip(new Rectangle2D.Float(100+ paintCount, 100+ paintCount, 100, 100));  // Only this is redrawn!!!
        gg2.setColor(new Color((100 + 10 * paintCount) % 255, (200 + paintCount) % 255, (100 + 10 * paintCount) % 255));
        gg2.fill(new Ellipse2D.Float
                (mouseX - radiusFromJFrame, mouseY - radiusFromJFrame, 2 * radiusFromJFrame, 2 * radiusFromJFrame));
    }

    private int rectInt(Graphics gg) {
        gg.fillRect(50, 50, 100, 200);
        return 3;
    }

    private Graphics2D textDraw(Graphics2D ggg2) {
         //@todo This really doesn't return a graphics value, info goes through argument only.
        //super.paint(g2);  // This step erases previous drawings on the buffer!!
        ggg2.setColor(new Color((100 + paintCount) % 255, (50 + 11 * paintCount) % 255, (100 + 20 * paintCount) % 255));
        ggg2.drawString("This is textDraw", 100f, 100f + ((float) paintCount * 2.7f) % this.getHeight());
        ggg2.drawString("Background = " + this.getBackground().toString(), 100, 250);
        return ggg2;
    }
}
