
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.geom.*;

/**
 * Created by IntelliJ IDEA.
 * User: unknown
 * Date: Oct 1, 2004
 * This is really page 76, using Graphics2D
 */
public class Transform2D extends JFrame {
    Rectangle2D bounds;
    GeneralPath arrow;  //user coordinates for figures
    GeneralPath square;
    GeneralPath arrowT; //transformed figures in user coords
    GeneralPath squareT;
    GeneralPath arrowDisplay; //display coordinates for figures
    GeneralPath squareDisplay;
    AffineTransform user2screen;
    AffineTransform screen2user;

    double xPixelsPerUser = 10;
    double yPixelsPerUser = 10;

    double xDisplayCenter = 400;
    double yDisplayCenter = 200;
    AffineTransform user;

    Timer timer;
    int count = 0; // number of times to setUpTimer animation
    double x = 40.0;
    double y = 75.0;
    double scale = 1.0;
    double rotate = 0.9;
    int boundX, boundY, boundW, boundH;

    private GeneralPath getArrow() {
        GeneralPath gp = new GeneralPath();
        gp.moveTo(0.0f, -15.0f);
        gp.lineTo(10.0f, 5.0f);
        gp.lineTo(5.0f, 5.0f);
        gp.lineTo(5.0f, 15.0f);
        gp.lineTo(-5.0f, 15.0f);
        gp.lineTo(-5.0f, 5.0f);
        gp.lineTo(-10.0f, 5.0f);
        gp.lineTo(0.0f, -15.0f);
        gp.closePath();
        return gp;
    }

    private GeneralPath getSquare() {
        GeneralPath gp = new GeneralPath();
        gp.moveTo(0.0f, 0.0f);
        gp.lineTo(1.0f, 0.0f);
        gp.lineTo(1.0f, 1.0f);
        gp.lineTo(0.0f, 1.0f);
        gp.closePath();
        return gp;
    }

    public Transform2D() {
        super("Transform2D.java");
        setUpGeometry();
        setUpTimer(1000);
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        timer.start();
        setSize(800, 400);
        setVisible(true);
    }

    private void setUpGeometry() {
        user2screen = new AffineTransform();
        // screen2user = user2screen.inverseTransform();
        user = new AffineTransform();
        // user2screen.setToTranslation(x, y);
        arrow = this.getArrow();
        square = this.getSquare();

        user = new AffineTransform();
        System.out.println("user = " + user);
        user2screen = new AffineTransform();
        System.out.println("user2screen - new = " + user2screen);
        // Flip user y axis and scale:
        user2screen.scale(xPixelsPerUser, -yPixelsPerUser);
        System.out.println("user2screen - flip and scale = " + user2screen);
        // Move to center of frame
        user2screen.translate(xDisplayCenter / xPixelsPerUser, yDisplayCenter / yPixelsPerUser);
        System.out.println("user2screen - translate = " + user2screen);
        System.out.println("end of setUpGeometry");


    }

    private void setUpTimer(int milliseconds) {
        timer = new Timer(milliseconds, new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                count++;
                repaint();
                System.out.println("count = " + count);
                if (count == 10) {
                    timer.stop();
                }
            }
        });
    }

    public void paint(Graphics g) {
        drawOperations(g);
    }

    private void drawOperations(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        //  getShapeBounds();
        //@todo Need to normalize to user coordinates, apply xform to figure, then display coords
//        System.out.println("boundX = " + boundX);
//        System.out.println("boundY = " + boundY);
//        System.out.println("boundW = " + boundW);
//        System.out.println("boundH = " + boundH);
        //  g2.clearRect(boundX, boundX, boundW, boundH);
        //    user2screen.setToTranslation(x, y);
        user.scale(scale, scale);
        System.out.println("user = " + user);
        user.rotate(rotate);
        arrowT = (GeneralPath) user.createTransformedShape(arrow);
        squareT = (GeneralPath) user.createTransformedShape(square);

        arrowDisplay = (GeneralPath) user2screen.createTransformedShape(arrow);
        squareDisplay = (GeneralPath) user2screen.createTransformedShape(square);

        // System.out.println("arrow.getBounds2D().toString()) = " + arrow.getBounds2D().toString());
        g2.setTransform(user2screen);
        g2.draw(arrowDisplay);
        g2.draw(squareDisplay);
        x += 1;
        scale *= 0.9;
        rotate += Math.PI / 8.0;
        // }
    }

    private void getShapeBounds() {
        boundX = (int) bounds.getMinX();
        boundY = (int) bounds.getMinY();
        boundW = (int) bounds.getWidth();
        boundH = (int) bounds.getHeight();
    }

    public static void main(String[] args) {
        Transform2D t = new Transform2D();
        System.out.println("This is " + t.toString());
    }
}
